tests: Use here-doc kadmin in Java test
[heimdal.git] / tests / kdc / check-uu.in
blob781715682b6685c43611c9860442a55bdd728950
1 #!/bin/sh
3 # Copyright (c) 2006 - 2007 Kungliga Tekniska Högskolan
4 # (Royal Institute of Technology, Stockholm, Sweden).
5 # All rights reserved.
7 # Redistribution and use in source and binary forms, with or without
8 # modification, are permitted provided that the following conditions
9 # are met:
11 # 1. Redistributions of source code must retain the above copyright
12 # notice, this list of conditions and the following disclaimer.
14 # 2. Redistributions in binary form must reproduce the above copyright
15 # notice, this list of conditions and the following disclaimer in the
16 # documentation and/or other materials provided with the distribution.
18 # 3. Neither the name of the Institute nor the names of its contributors
19 # may be used to endorse or promote products derived from this software
20 # without specific prior written permission.
22 # THIS SOFTWARE IS PROVIDED BY THE INSTITUTE AND CONTRIBUTORS ``AS IS'' AND
23 # ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
24 # IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
25 # ARE DISCLAIMED. IN NO EVENT SHALL THE INSTITUTE OR CONTRIBUTORS BE LIABLE
26 # FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
27 # DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
28 # OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
29 # HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
30 # LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
31 # OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
32 # SUCH DAMAGE.
34 env_setup="@env_setup@"
35 objdir="@objdir@"
36 srcdir="@srcdir@"
38 testfailed="echo test failed; cat messages.log; exit 1"
40 . ${env_setup}
42 # If there is no useful db support compiled in, disable test
43 ${have_db} || exit 77
45 R=TEST.H5L.SE
47 uuspid=
49 port=@port@
51 kadmin="${TESTS_ENVIRONMENT} ../../kadmin/kadmin -l -r $R"
52 kdc="${TESTS_ENVIRONMENT} ../../kdc/kdc --addresses=localhost -P $port"
54 cache1="FILE:${objdir}/cache1.krb5"
55 cache2="FILE:${objdir}/cache2.krb5"
57 kinit1="${TESTS_ENVIRONMENT} ../../kuser/kinit -c $cache1 ${afs_no_afslog}"
58 kinit2="${TESTS_ENVIRONMENT} ../../kuser/kinit -c $cache2 ${afs_no_afslog}"
59 kdestroy1="${TESTS_ENVIRONMENT} ../../kuser/kdestroy -c $cache1 ${afs_no_unlog}"
60 kdestroy2="${TESTS_ENVIRONMENT} ../../kuser/kdestroy -c $cache2 ${afs_no_unlog}"
61 uu_server="${TESTS_ENVIRONMENT} ../../appl/test/uu_server"
62 uu_client="${TESTS_ENVIRONMENT} ../../appl/test/uu_client"
64 KRB5_CONFIG="${objdir}/krb5.conf"
65 export KRB5_CONFIG
67 rm -f current-db*
68 rm -f out-*
69 rm -f mkey.file*
71 > messages.log
73 echo Creating database
74 ${kadmin} <<EOF || exit 1
75 init --realm-max-ticket-life=1day --realm-max-renewable-life=1month ${R}
76 add -p foo --use-defaults user1@${R}
77 add -p foo --use-defaults user2@${R}
78 check ${R}
79 EOF
81 echo foo > ${objdir}/foopassword
83 echo Starting kdc ; > messages.log
84 ${kdc} --detach --testing || { echo "kdc failed to start"; cat messages.log; exit 1; }
85 kdcpid=`getpid kdc`
87 cleanup() {
88 echo signal killing kdc
89 kill -9 ${kdcpid} ${uuspid} 2>/dev/null
90 trap '' EXIT INT TERM
91 cat messages.log
92 exit 1
94 trap cleanup EXIT INT TERM
96 ec=0
98 echo "Getting client initial tickets user1"; > messages.log
99 ${kinit1} --password-file=${objdir}/foopassword user1@$R || \
100 { ec=1 ; eval "${testfailed}"; }
102 echo "Getting client initial tickets user2"; > messages.log
103 ${kinit2} --password-file=${objdir}/foopassword user2@$R || \
104 { ec=1 ; eval "${testfailed}"; }
107 echo "starting uu server (using user1)"
108 KRB5CCNAME=$cache1 ${uu_server} > uuserver.log &
109 uuspid=$!
110 sleep 5
112 echo "trying to contact server with client (using user2)"
113 KRB5CCNAME=$cache2 ${uu_client} localhost > messages.log 2>&1 || \
114 { ec=1; eval "${testfailed}"; }
116 sleep 5
118 echo "checking if server got the right message"
119 cmp uuserver.log ${srcdir}/uuserver.txt || \
120 { ec=1; eval "${testfailed}"; }
122 uuspid=""
124 ${kdestroy1}
125 ${kdestroy2}
127 echo "killing kdc uu_server (${kdcpid} ${uuspid})"
128 sh ${leaks_kill} kdc $kdcpid || exit 1
131 trap "" EXIT
133 exit $ec